/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 */

#include "IScheduler.h"
#include "../../common/DebugManager.h"
#include "../core/configuration/Configuration.h"

std::string IScheduler::sendername = "scheduler";

void IScheduler::printDebugMessage(std::string message)
{
    DebugManager::getInstance().printDebugMessage(IScheduler::sendername, message);
}

// Get the next command that is necessary to process the request representend by the payload
Command IScheduler::getNextCommand(gp &payload)
{
    Bank bank = DramExtension::getBank(payload);
    if (!controllerCore.getRowBufferStates().rowBufferIsOpen(bank)) {
        return Command::Activate;
    } else if (controllerCore.getRowBufferStates().rowBufferIsOpen(bank) &&
               controllerCore.getRowBufferStates().getRowInRowBuffer(bank) !=
               DramExtension::getRow(payload)) {
        return Command::Precharge;
    } else {
        return getReadWriteCommand(payload);
    }
}

Command IScheduler::getNextCommand(gp *payload)
{
    return getNextCommand(*payload);
}

Command IScheduler::getReadWriteCommand(gp &payload)
{

    if (payload.get_command() == tlm::TLM_READ_COMMAND) {
        if (Configuration::getInstance().OpenPagePolicy)
            return Command::Read;
        else
            return Command::ReadA;
    } else {
        if (Configuration::getInstance().OpenPagePolicy)
            return Command::Write;
        else
            return Command::WriteA;
    }
}

Command IScheduler::getReadWriteCommand(gp *payload)
{
    return getReadWriteCommand(*payload);
}
